import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
} from '@overflow/commons/core/type';

export interface RunnerAnnotationAttributes {
}

export class RunnerAnnotation extends Annotation {
  public readonly attributes: RunnerAnnotationAttributes = {
  };

  public constructor() {
    super();
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('Runner');
  }

}

export const Runner = Decorator.create(RunnerAnnotation);
