import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

export interface PostConstructAnnotationAttributes {
}

export class PostConstructAnnotation extends Annotation {
  public readonly attributes: PostConstructAnnotationAttributes = {
  };

  public constructor() {
    super();
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('PostConstruct');
  }

}

export const PostConstruct = Decorator.create(PostConstructAnnotation);
